
#ifndef KORNERS_ENGINE_THREAD
#define KORNERS_ENGINE_THREAD

#include <QThread>
#include <QVector>

#include "korners_game_engine.h"

class KornersScene;


class KornersEngineThread : public QThread
{
    Q_OBJECT
public:

    explicit KornersEngineThread( KornersScene* sc = 0 );
    ~KornersEngineThread();

    void run();
  
    enum StartType
    {
        none = 0,
        ai = 1,
        network_clnt = 2,
        network_serv = 3,
    };
    
public slots:
    void startGameEngineAI();
    void startGameEngineNetwork( const QString& net_name, int port, bool server = false,
                                 const QString& ip_adress = "localhost" );

private:

    StartType sType;  
    QVector<QVariant> startParams;
    KornersEngine* curGameEngine;
    KornersScene* m_scene;
    
    inline void restart()
    {
        if( isRunning() )
        {
            quit();
            wait();
            start();
        }
        else
            start();
    }
};

#endif