
#ifndef KORNERS_GAME_ENGINE_NETWORK
#define KORNERS_GAME_ENGINE_NETWORK

#include "korners_game_engine.h"
#include "korners_protocol.h"

class KornersSocket;
class KornersServer;

class KornersGameEngineNetwork : public KornersEngine
{
    Q_OBJECT
public:

    explicit KornersGameEngineNetwork(  const QString& netName, bool server, int port, 
                                        const QString& peerIp = "localhost");

    ~KornersGameEngineNetwork();

    void makeNextMove( const QPoint& src, const QPoint& dst );

public slots:
    void messageReceived( KornersMessage mess );
    void incomingConnection();
    void onDisconnect();
    void connectionFailed();

signals:
    void opponentName( QString name );

private:
    QString m_nickName;
    QString m_peerName;
    KornersProtocol* m_curGameProto;
    KornersSocket* m_socket;
    KornersServer* m_server;
};

#endif