
#ifndef KORNERS_GRAPHICS_ITEMS
#define KORNERS_GRAPHICS_ITEMS

#include <QGraphicsPixmapItem>

class QPoint;

class KornersGraphicsItem : public QGraphicsPixmapItem
{
public:
    KornersGraphicsItem( QPixmap pm ) : QGraphicsPixmapItem(pm) 
    {}

    KornersGraphicsItem()
    {}

    // enable use of qgraphicsitem_cast
    enum { Type = UserType + 1 };
    virtual int type() const { return Type; }

    void setPos(const QPoint& newPos)
    {
        position = newPos;
    }

    const QPoint& getPos() const
    {
	return position;
    }
private:
    QPoint position;
};

class KornersCapItem : public KornersGraphicsItem
{
public:
    enum owner
    {
        player = 1,
        opponent = 2,
    };

    KornersCapItem( QPixmap pm, owner own ) : KornersGraphicsItem(pm)
    {
        m_whos = own;
    }

    enum { Type = UserType + 2 };
    virtual int type() const { return Type; }
 
    owner whos() const
    {
        return m_whos;
    }
private:
    owner m_whos;
};

class KornersHighlightItem : public KornersGraphicsItem
{
public:
    enum { Type = UserType + 3 };
    virtual int type() const { return Type; }
};

#endif