
#include "korners_widget.h"
#include "korners_scene.h"

#include <QGraphicsView>
#include <QResizeEvent>
#include <QBoxLayout>


KornersWidget::KornersWidget( QWidget* parent ) : QWidget( parent )
{
    QBoxLayout *mainLay = new QHBoxLayout( this );
    mainLay->setMargin( 0 );

    m_scene = new KornersScene(this);
    QGraphicsView* klview = new QGraphicsView( m_scene, this );
    klview->setCacheMode( QGraphicsView::CacheBackground );
    klview->setVerticalScrollBarPolicy( Qt::ScrollBarAlwaysOff );
    klview->setHorizontalScrollBarPolicy( Qt::ScrollBarAlwaysOff );
    klview->setFrameStyle( QFrame::NoFrame );

    klview->setOptimizationFlags( QGraphicsView::DontClipPainter |
                                  QGraphicsView::DontSavePainterState |
                                  QGraphicsView::DontAdjustForAntialiasing );

    mainLay->addWidget( klview );

    setMinimumSize( 250, 250 );
}

void KornersWidget::resizeEvent( QResizeEvent* evt)
{
    // if this flag is set it means that resizeEvent is called
    // while widget is hidden.
    // so we'll wait with resize until it will be unset to not
    // waste time resizing invisible scene
    if ( !testAttribute( Qt::WA_PendingResizeEvent ) )
        m_scene->resizeScene( evt->size().width(), evt->size().height() );
}


